This file describes how to deploy local project onto remote server.

It's applicable if you're a developer that develops **vkclone** and is about to push a copy of project onto remote server.

---
#####1. Set **REMOTE_DIR** in **protected/config/local/config.sh** according with rsync remote shell format **&lt;[remote user]@[remote server]:[path to the site public html dir]&gt;**.
In my case, file **protected/config/local/config.sh** looks so
```
## rsync options
## used in ./deploy.sh
RSYNC_OPTIONS="--exclude /assets/
--exclude /protected/config/database.php \
--exclude /protected/config/config.sh \
--exclude /protected/logs/ \
--exclude /protected/runtime/ \
--exclude /static/"

## remote dir
## used in ./deploy.sh by rsync
REMOTE_DIR=wapcode.ru:/var/www/default/public_html/vkclone/
```
I omit *remote user* because remote user's name is wapmorgan too.

#####2. Run `./deploy.sh` on local machine to copy files onto remote server

#####3. Login via shell on remote server under **remote user**

#####4. Go to the path to the site public html dir

#####5. Run `./setup.sh` to create runtime directories
