This file describes **vkclone** requirements (system software and yii extensions).

---
### Software
* **Web server** (nginx or apache). I prefer *nginx*.
* **bash** for running setup and deploy scripts.
* **PHP >=5.3**. Required extensions: **pdo_mysql**, **gd** for image resizing, **mbstring**, **memcached**, **gearman**, **xdiff** to make diffs and patch forum posts.
* **Memcached** for data caching. If you don't want to use *memcached*, then delete file **protected/config/local/caching.php**
* **MySQL server** for data storing.
* **Gearman** for managing queues. **SQLite3** also required as an indirect dependency.

---
### Extensions
Every extension most likely is a git submodule.
**Foreign extensions:**

- **yii** - Yii framework. Used version is 1.1.14 (latest 1.1.x stable). Project'page is http://www.yiiframework.com/.
- **bootstrap** - twitter bootstrap's binding to Yii. Project's home page is http://www.getyiistrap.com/site/index.
- **gearman-application** - platform to make application a gearman worker. Project's page is https://github.com/vkclone/gearman--pplication.
- **gearman-wrapper** - wrapper of GearmanClient/GearmanWorker. Project's page is https://github.com/vkclone/gearman-wrapper.

**My extensions:**

- **SelectorWidget**.
- **RetrieveRecordFilter**.
- **StaticManager**.
- **ImageEditor**.
- **ExtendedDateTimeFormattingBehavior**.
- **SortableModel**.
