<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<?php Yii::app()->bootstrap->register(); ?>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta name="language" content="en" />
	<title>[<?= Yii::app()->request->serverName ?>] <?php echo $this->pageTitle; ?></title>
	<link rel="icon" href="<?= Yii::app()->baseUrl ?>/favicon.ico" type="image/x-icon"></link>
	<link rel="shortcut icon" href="<?= Yii::app()->baseUrl ?>/favicon.ico" type="image/x-icon"></link>
		<style>
		/* Using for break long urls in table rows */
		.breaked {
			word-break: break-all;
		}
		.small {
			font-size: 0.8em;
		}
		</style>
	</head>
<body>

<!-- navbar -->
	<?php $this->widget('bootstrap.widgets.TbNavbar', array(
		'color' => TbHtml::NAVBAR_COLOR_INVERSE,
		'brandLabel' => Yii::app()->name,
		'brandUrl' => Yii::app()->baseUrl,
		'fluid' => true,
		'display' => TbHtml::NAVBAR_DISPLAY_NONE,
		'collapse' => true,
		'items' => array(
			array(
				'class' => 'bootstrap.widgets.TbNav',
				'items' => array(
					array('label' => Yii::t('Admin', 'Dashboard'), 'url' => array('/admin/default/dashboard')),
					TbHtml::navbarMenuDivider(),
					array('label' => Yii::t('Admin', 'Modules'), 'items' => $this->moduleLinks),
					array('label' => Yii::t('Admin', 'Settings'), 'items' => $this->settingsLinks),
					TbHtml::navbarMenuDivider(),
					array('label' => Yii::t('Admin', 'Gearman'), 'url' => array('/admin/default/gearman')),
					array('label' => Yii::t('Admin', 'Check system'), 'url' => array('/admin/default/check')),
				),
			),
			array(
				'class' => 'bootstrap.widgets.TbNav',
				'htmlOptions' => array('class' => 'pull-right'),
					'items' => array(
						array('label' => Yii::t('Admin', 'Go to site ⇾'), 'url' => Yii::app()->baseUrl),
				),
			),
		),
	)); ?>
<!-- navbar -->

<!-- container -->
	<div class="container-fluid" id="page">
		<!-- breadcrumbs -->
			<?php if (!empty($this->breadcrumbs)): ?>
				<?= TbHtml::breadcrumbs($this->breadcrumbs) ?>
			<?php endif?>
		<!-- breadcrumbs -->
		<!-- content -->
			<?php echo $content; ?>
		<!-- content -->
		<div class="clear"></div>
		<hr />
			<footer>
				<div class="row">
					<div class="span3">
						<?= Yii::t('Admin', 'Generated in {sec} sec', array('{sec}' => round(Yii::getLogger()->getExecutionTime(), 2))) ?><br />
						<?= Yii::t('Admin', 'Consumed {memory}', array('{memory}' => Yii::app()->format->formatSize(Yii::getLogger()->memoryUsage))) ?>
					</div>
					<div class="span3 offset6">
						<p class="powered">
						<?= CHtml::link(Yii::app()->request->serverName, $this->createAbsoluteUrl('/')) ?> copyright &copy; 2013<?= (date('Y') - 2013 > 0 ? ' - '.date('Y') : null) ?> by wapmorgan.<br />
						<?php echo Yii::powered(); ?>
						</p>
					</div>
				</div>
			</footer>
	</div>
<!-- container -->
</body>
</html>
