<?php
class DefaultController extends FrontEndController {
	public function actionIndex() {
		$model = new CPublic('search');
		$model->unsetAttributes();
		if (isset($_GET[CHtml::modelName(CPublic::model())]))
			$model->attributes = $_GET[CHtml::modelName(CPublic::model())];
		$this->render('index', array(
			'model' => $model,
			'publics' => new CActiveDataProvider(CPublic::model()),
		));
	}

	/**
	 * Shows recently created topics
	 */
	public function actionRecent() {
		$this->render('recent', array(
			'publics' => new CActiveDataProvider(CPublic::model(), array('criteria' => array(
				'order' => 'created_at',
			))),
		));
	}

	/**
	 * Shows topics I created
	 */
	public function actionMy($user = null) {
		if ($user === null || $user == Yii::app()->user->record->id) {
			$user = Yii::app()->user->record;
			$model = new CPublic('create');
			$model->creator_id = Yii::app()->user->record->id;
			if (isset($_POST[CHtml::modelName($model)])) {
				$model->attributes = $_POST[CHtml::modelName($model)];
				if ($model->validate()) {
					if ($model->create()) {
						Yii::app()->user->setAlert(Yii::t('Publics', 'Public created'), 'success');
						$this->refresh();
					}
				}
			}
		} else {
			if (($user = User::model()->findByPk($user)) === null)
				throw new CHttpException(404, 'Invalid User!');
		}

		$this->render('my', array(
			'user' => $user,
			'model' => isset($model) ? $model : null,
			'publics' => new CActiveDataProvider(CPublic::model(), array('criteria' => array(
				'condition' => 'creator_id = :creator_id',
				'params' => array(':creator_id' => $user->id),
				'order' => 'total_readers',
			))),
		));
	}
}
