<?php
class AdminController extends BackEndController {
	public function actionIndex() {
		$this->render('index');
	}

	/**
	 * Site settings
	 */
	public function actionSettings() {
		$model = $this->module->settings;
		if (isset($_POST[CHtml::modelName($model)])) {
			$model->attributes = $_POST[CHtml::modelName($model)];
			if ($model->validate()) {
				$model->save();
				Yii::app()->user->setFlash('success', Yii::t('Site', 'Site settings successfully saved'));
				$this->refresh();
			}
		}
		$this->render('settings', array(
			'model' => $model,
		));
	}

	/**
	 * Site settings
	 */
	public function actionClose() {
		$model = $this->module->settings;
		if (isset($_POST[CHtml::modelName($model)])) {
			$model->siteClosed = !isset($_POST['open']);
			$model->attributes = $_POST[CHtml::modelName($model)];
			if ($model->validate()) {
				$model->save();
				Yii::app()->user->setFlash('success', Yii::t('Site', $model->siteClosed ? 'Site closed' : 'Site opened'));
				$this->refresh();
			}
		}
		$this->render('close', array(
			'model' => $model,
		));
	}
}
