<?php
$this->pageTitle = Yii::t('Site', 'Close site');
$this->breadcrumbs = array(
	$this->module->getMeta('name') => Yii::app()->createUrl($this->module->id.'/'.$this->module->getMeta('admin.controller')),
	$this->pageTitle,
);
?>

<div class="row-fluid">
	<div class="span2 well">
		<?php $this->module->renderAdminWidget(); ?>
	</div>
	<div class="span10">
	<?php $this->widget('bootstrap.widgets.TbAlert', array(
			'alerts' => array(
					'success' => array('block' => true, 'fade' => true, 'closeText' => '&times;'),
			),
	)); ?>
	<?php
	$form = $this->beginWidget('bootstrap.widgets.TbActiveForm', array(
		'layout' => TbHtml::FORM_LAYOUT_HORIZONTAL,
	)); ?>

	<?= $form->errorSummary($model) ?>

	<fieldset>
		<legend><?= $this->pageTitle ?></legend>

		<?php echo $form->textAreaControlGroup($model, 'siteClosedMessage', array('span' => 12, 'rows' => 5, 'help' => 'Administrators can always authenticate by passing <code>?admin</code> to the login page path.')); ?>

	</fieldset>

	<?= TbHtml::formActions(array(
		TbHtml::submitButton(Yii::t('Site', $model->siteClosed ? 'Change message' : 'Close site'), array(
			'color' => TbHtml::BUTTON_COLOR_DANGER,
			'name' => 'close',
		)),
		$model->siteClosed
		? TbHtml::submitButton(Yii::t('Site', 'Open site'), array(
				'color' => TbHtml::BUTTON_COLOR_PRIMARY,
				'name' => 'open',
			))
		: null,
	)); ?>

	<?php $this->endWidget(); ?>

	</div>
</div>
