<?php
class DefaultController extends FrontEndController {
	public function accessRules() {
		return CMap::mergeArray(array(
			array('allow',
				'actions' => array('index', 'dialog'),
				'users' => array('@'),
			),
		), parent::accessRules());
	}

	/**
	 * Renders talks list
	 */
	public function actionIndex() {
		$count = Yii::app()->db->createCommand('SELECT COUNT(*)
FROM (SELECT user_id
FROM '.UserMessage::model()->tableName().'
WHERE receiver_id = '.$this->webUser->id.'
UNION
SELECT receiver_id
FROM '.UserMessage::model()->tableName().'
WHERE user_id = '.$this->webUser->id.') as talks;')->queryScalar();

		$sql = 'SELECT user_id, MAX(created_at) as updated_at, sum(new) as new_messages
FROM (SELECT user_id, created_at, new
FROM '.UserMessage::model()->tableName().'
WHERE receiver_id = '.$this->webUser->id.'
UNION
SELECT receiver_id, created_at, 0
FROM '.UserMessage::model()->tableName().'
WHERE user_id = '.$this->webUser->id.'
ORDER BY created_at DESC) as talks
GROUP BY user_id
ORDER BY created_at DESC;';

		$this->render('index', array(
			'talks' => new CSqlDataProvider($sql, array(
				'keyField' => 'user_id',
				'totalItemCount' => $count,
			)),
		));
	}

	/**
	 * Shows talk
	 */
	public function actionDialog($id) {
		if (is_null($user = User::model()->findByPk($id)) || $user->id == $this->webUser->id)
			$this->redirect('index');

		$model = new UserMessage('create');
		$model->user_id = $this->webUser->id;
		$model->receiver_id = $user->id;
		$model->new = "1";
		if (isset($_POST[CHtml::modelName($model)])) {
			$model->attributes = $_POST[CHtml::modelName($model)];
			if ($model->validate() && $model->save()) {
				$this->refresh();
			}
		}

		$messages = new CActiveDataProvider(UserMessage::model(), array(
				'criteria' => array(
					'scopes' => array(
						'getTalk' => array($this->webUser->id, $user->id),
					),
					'order' => 'created_at DESC',
				),
			));
		// unmark messages as new
		foreach ($messages->getData() as $message) {
			if ($message->receiver_id == $this->webUser->id && $message->isNew()) {
				$this->unreadMessages--;
				$message->unmarkNew();
			}
		}
		$this->render('dialog', array(
			'user' => $user,
			'messages' => $messages,
			'model' => $model,
		));
	}
}
